(defun is-delim (c)
  "Zwraca nie-nil jeli C jest ogranicznikiem sowa"
  (position c " 	.,;:/!?\"(){}*&%$-"))

(defun is-end-of-sentence (c)
  "Zwraca nie-nil jeli C jest znakiem interpunkcyjnym koczcym zdanie"
  (position c "?!."))

(defun tokenize (string)
  "Rozbija acuch STRING na sowa. Zwraca list sw.
Uwaga/FIXME: lista nie zawiera znakw interpunkcyjnych."
  (let ((len (length string)))
    (do ((pos 0 (or (position-if-not #'is-delim string :start pos)
		    len))
	 (r))
	((= pos len) (nreverse r))
      (let* ((end (or (position-if #'is-delim string :start pos)
		      len)))
	(when (> end pos)
	  (setq r (cons (string-downcase (substring string pos end)) r))
	  (setq pos end))))))

(defun tokenize-stream (&optional str)
  "Czyta dane ze strumienia STR i rozbija je na pojedyncze zdania. Przetwarza zdania
na listy sw i zwraca list, w ktrej kademu zdaniu odpowiada cons o nastpujcej
zawartoci:

    LISTA . ZNAK

gdzie LISTA jest list sow w zdaniu, ZNAK jest znakiem interpunkcyjnym koczcym zdanie"
  (let ((sentence ""))
    (do* ((line (read-line str nil nil))
	  (val))
	((not line) (nreverse val))
      (let ((pos (position-if #'is-end-of-sentence line)))
	(cond
	 (pos
	  (setq val (cons (cons
			   (tokenize (string-concat sentence " " (substring line 0 pos)))
			   (aref line pos))
			  val))
	  (setq sentence "")
	  (setq line (substring line (1+ pos))))
	 (t
	  (setq sentence (string-concat sentence " " line))
	  (setq line (read-line str nil nil))))))))


